'use strict';

exports.__esModule = true;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _lodashLangIsFunction = require('lodash/lang/isFunction');

var _lodashLangIsFunction2 = _interopRequireDefault(_lodashLangIsFunction);

function createActionHandler(ignore) {
  // redux-ignore higher order reducer
  return function handleAction(reducer) {
    var actions = arguments.length <= 1 || arguments[1] === undefined ? [] : arguments[1];

    var predicate = _lodashLangIsFunction2['default'](actions) ? actions : function (action) {
      return actions.indexOf(action.type) >= 0;
    };

    return function (state, action) {
      if (predicate(action)) {
        return ignore ? state : reducer(state, action);
      }

      return ignore ? reducer(state, action) : state;
    };
  };
}

var ignoreActions = createActionHandler(true);
exports.ignoreActions = ignoreActions;
var filterActions = createActionHandler(false);

exports.filterActions = filterActions;
exports['default'] = ignoreActions;

// /redux-ignore